# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api
import openerp.addons.decimal_precision as dp
from datetime import datetime

class accountLoanType(models.Model):
    _name = 'account.loan.type'

    name = fields.Char('Name', required=True)
    rate_division  = fields.Integer('Tasa de división', help="Tasa de división\n"\
                                                            " * Días 365 \n"\
                                                            " * Semana 48\n"\
                                                            " * Mes 12", required=True)
    interest_rate_year = fields.Float('Tasa de interés anual(%)', digits=(3,6), digits_compute=dp.get_precision('Account Loan'), required=True, help="Tasa de interés anual(%)")
    interest_rate = fields.Float('Tasa de interés calculado(%)', digits=(3,6), digits_compute=dp.get_precision('Account Loan'), readonly='readonly', required=True, help="Tasa de interés calculado(%)")
    expiration_days  = fields.Integer('Cantidad de días para generar la fecha del próximo vencimiento', help="Cantidad de días para  generar  la fecha  del próximo  vencimiento")
    comment = fields.Text('Comment', help="Información adicional")
    active =  fields.Boolean('active',default=True)

    '''
        Create default type loan
    '''
    @api.model
    def _create_account_loan_type(self):
        decimal_precision = self.env['decimal.precision'].precision_get('Account Loan')
        rateInterest = [
                        {'name': 'Mensual', 'rate_division': 12,'interest_rate_year': 40.00, 'expiration_days': 30},
                        {'name': 'Semanal', 'rate_division': 48, 'interest_rate_year': 364, 'expiration_days': 7},
                        {'name': 'Semanal-Alternativo', 'rate_division': 48, 'interest_rate_year': 465, 'expiration_days': 7},
                        {'name': 'Diario', 'rate_division': 365, 'interest_rate_year': 38.80, 'expiration_days': 1}
        ]
        for line in rateInterest:
            loanType = self.env['account.loan.type'].search([('name', '=', line['name'])])
            if (not loanType):
                interst = round(self._calculate_rate_interest(float(line['rate_division']), float(line['interest_rate_year'])), decimal_precision)
                loanType.create({
                    'name':  line['name'],
                    'rate_division': round(line['rate_division'], decimal_precision),
                    'interest_rate_year': round(line['interest_rate_year'], decimal_precision),
                    'interest_rate': interst,
                    'expiration_days': line['expiration_days']
                })

        return True

    '''
        Calcular la tasa de interes
            (Tasa de interés anual(%) / Tasa de división)
    '''
    def _calculate_rate_interest(self, rateDivision,interestYear):
        return (interestYear / rateDivision)



class eiruAccountLoan(models.Model):
    _inherit = 'account.loan'

    ''' Tipo de plazo del prestamos (Días, Semana , Mes, Año) '''
    loan_type = fields.Many2one('account.loan.type', string='Tipo de préstamo', ondelete='restrict', index=True, required=True, help="Tipo de plazo del prestamos (Días-Semana-Mes)")
